﻿using System;
using System.Configuration;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace WebDisplayASimpleMap
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF")); ;
                Map1.CurrentExtent = new RectangleShape(-180, 89, 180, -89);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(Server.MapPath("~/app_Data/Countries02.shp"));
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay lo = new LayerOverlay("worldOverlay");
                lo.Layers.Add("worldLayer", worldLayer);


                Map1.CustomOverlays.Add(lo);

                SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay("MarkerOverlay");
                Map1.CustomOverlays.Add(markerOverlay);
            }
        }

        protected void AddMarkerButton_Click(object sender, EventArgs e)
        {
            string inputCountryName = txtCountryName.Text.Trim().ToUpper();
            SimpleMarkerOverlay markerOverlay = (SimpleMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];

            ShapeFileFeatureLayer worldLayer = (Map1.CustomOverlays["worldOverlay"] as LayerOverlay).Layers["worldLayer"] as ShapeFileFeatureLayer;
            worldLayer.FeatureSource.Open();

            var queringFeatures = worldLayer.FeatureSource.GetFeaturesByColumnValue("CNTRY_NAME", inputCountryName);
            if (queringFeatures != null && queringFeatures.Count > 0)
            {
                Feature selectedFeature = queringFeatures[0];
                Marker addingMarker = new Marker(selectedFeature.GetBoundingBox().GetCenterPoint());

                addingMarker.Popup.ContentHtml = string.Format("<div style='font-size:11px'>{0}</Div>", inputCountryName);
                addingMarker.Popup.Height = 30;
                addingMarker.Popup.Width = 50;

                markerOverlay.Markers.Add(addingMarker);
            }
        }
    }
}